package u8c.ui.mm.action;
import nc.ui.hr.frame.action.QueryAction;
import nc.ui.hr.global.Global;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.flexdock.util.UUID;

import chrriis.dj.nativeswing.swtimpl.Message;
import nc.bs.framework.common.NCLocator;
import nc.bs.pub.billcodemanage.BillcodeGenerater;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.itf.uap.pf.IplatFormEntry;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.md.data.access.NCObject;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIDialog;
import nc.vo.AqkcVO;
import nc.vo.DemandUAPBVO;
import nc.vo.MRPDemandVO;
import nc.vo.OnhandunmUAPVO;
import nc.vo.OperationBalanceVO;
import nc.vo.OperationDemandVO;
import nc.vo.OperationMainVO;
import nc.vo.OperationPurchaseVO;
import nc.vo.OperationSupplyVO;
import nc.vo.OperationTransferVO;
import nc.vo.OrderIssueUAPVO;
import nc.vo.SafetystockVO;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.ic.pub.bill.SpecialBillHeaderVO;
import nc.vo.ic.pub.bill.SpecialBillItemVO;
import nc.vo.ic.pub.bill.SpecialBillVO;
import nc.vo.pr.pray.PraybillHeaderVO;
import nc.vo.pr.pray.PraybillItemVO;
import nc.vo.pr.pray.PraybillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.ISuperVO;
import nc.vo.pub.ValidationException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.ui.mm.panel.OperationTestUI;
import u8c.vo.ExAggOrderMainVO;

/**
 * MRP运算清单-运算按钮
 *@Author: ZTH
 *@Date:2023年11月14日 下午3:19:50
 *@Version: V1.0
 */

public class YsAction extends YsQuseryAction{
	private static final ResultSetProcessor MapListProcessor = null;
	private OperationTestUI operframui=null;
	private IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private IVOPersistence ivo = NCLocator.getInstance().lookup(IVOPersistence.class);
	private IplatFormEntry iIplatFormEntry = (IplatFormEntry)NCLocator.getInstance().lookup(IplatFormEntry.class.getName());
	public YsAction(FrameUI frameUI1) {
		super(frameUI1);
		this.operframui = (OperationTestUI) frameUI1;
	}

	public void execute() throws Exception {
	    //查询数据弹框
		Boolean iscancel=Boolean.FALSE;
		MRPDialogdura dialog = new MRPDialogdura(ClientEnvironment.getInstance().getUser().getPrimaryKey(),
				 ClientEnvironment.getInstance().getCorporation().getPk_corp(),iscancel);
		dialog.show();
		
		if(dialog.dg_iscancel) {
			String butype = dialog.getButype();//业务类型下拉--- 家装\工装
			String xmname = dialog.getXmname();//项目主键
			String xmcode = dialog.getXmcode();//工单号
			String chfl=dialog.getChfl();//存货分类
			/**
			 * 
			 * 查询生产总订单和材料采购单数据生成
			 * 
			 * 需求页签
			 * 
			 */
			
			if("工装".equals(butype)) {
				List<OperationSupplyVO> supplyvos=new ArrayList<OperationSupplyVO>();
				String pk_operation="";//单据主键
				//查询生产总订单材料明细不是委外的数据
				String sqlmmpac="select a.dbilldate demanddate ,b.* from  mmpac_order_issue b "
						+ "inner join mmpac_order_main a on  a.pk_order=b.pk_order "
						+ "and isnull(a.dr,0)=0 and isnull(b.dr,0)=0 and isnull(b.bdef5,'N')='N' "
						+ "and a.projectid='" + xmname + "' and a.busitype='" + butype + "' and a.billstatus='1' and a. def1='"+xmcode+"' and 1=2 ";
				
				List<OrderIssueUAPVO> lisvos= (List<OrderIssueUAPVO>) iuap.executeQuery(sqlmmpac, new BeanListProcessor(OrderIssueUAPVO.class));
				
				//查询材料采购单的数据
				String sqlxc="select  a.dbilldate demanddate,a.vdef1 gdcode ,b.* from  po_demand_b b "
						+ "inner join po_demand a on  a.pk_demand=b.pk_demand "
						+ "and isnull(a.dr,0)=0 and isnull(b.dr,0)=0  "
						+ "and a.projectid='" + xmname + "' and a.vdef30='" + butype + "' and a.billstatus='1' and a.billstatus<>'9' and  a.billstatus<>'10'  and a.vdef1='"+xmcode+"' ";
				
				
				//查询 材料采购单的单据号，用于回写标识
				String sqlcode="select a.vbillcode  from  po_demand a "
						+ "where isnull(a.dr,0)=0  "
						+ "and a.projectid='" + xmname + "' and a.vdef30='" + butype + "' "
						+ "and a.billstatus='1' and a.billstatus<>'9' and  a.billstatus<>'10'  and a.vdef1='"+xmcode+"' ";
				
				
				List<DemandUAPBVO> lisdemvos= (List<DemandUAPBVO>) iuap.executeQuery(sqlxc, new BeanListProcessor(DemandUAPBVO.class));
				String vbillcode=new BillcodeGenerater().getBillCode("MM01", PubEnv.getPk_corp(), null, null);
				List<OperationDemandVO> demandvos=new ArrayList<OperationDemandVO>();
				List<String> liscodes=new ArrayList<String>();//读取的材料采购单，单据号
				if((null!=lisvos && lisvos.size()>0) || (null!=lisdemvos && lisdemvos.size()>0)) {
					OperationMainVO opmainvo=new OperationMainVO();
					opmainvo.setBillmaker(ClientEnvironment.getInstance().getUser().getPrimaryKey());
					opmainvo.setDbilldate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
					opmainvo.setBusitype(butype);
					opmainvo.setBillstatus(8);
					opmainvo.setPk_corp(PubEnv.getCorpCode());
					opmainvo.setProjectid(xmname);
					opmainvo.setVbillcode(vbillcode);
					opmainvo.setVdef28(xmcode);//工单号            
					pk_operation=ivo.insertVO(opmainvo);
					liscodes= (List<String>) iuap.executeQuery(sqlcode, new ColumnListProcessor());
					
					/********************************生成【需求】页签数据-begin*********************************************/

				try{	
					if(null!=lisvos && lisvos.size()>0) {
						for(OrderIssueUAPVO vo : lisvos) {//bdef3
							OperationDemandVO demandvo=new OperationDemandVO();//vdef13
							for (String name : demandvo.getAttributeNames()) {
								if("ts".equals(name)||"execnum".equals(name)) {
									continue;
								}else if("pk_operation".equals(name)) {
									demandvo.setAttributeValue(name, pk_operation);
								}else if("demandtyoe".equals(name)) {
									demandvo.setAttributeValue(name, "生产总订单");
								}else if("nastnum".equals(name)) {
									demandvo.setNastnum(vo.getNastnum());
								}else {
									String oldname=name;
									String newname=name;
									if(name.contains("vdef")) {
										newname=newname.replace("vdef", "bdef");
									}
									demandvo.setAttributeValue(oldname, vo.getAttributeValue(newname));
								}
								
							}
							demandvos.add(demandvo);
						}
					}
			
					if(null!=lisdemvos && lisdemvos.size()>0) {
						for(DemandUAPBVO vo:lisdemvos) {
							OperationDemandVO demandvo=new OperationDemandVO();
							for (String name : demandvo.getAttributeNames()) {
								if("ts".equals(name)||"execnum".equals(name)) {
									continue;
								}else if("pk_operation".equals(name)) {
									demandvo.setAttributeValue(name, pk_operation);
								}else if("demandtyoe".equals(name)) {
									demandvo.setAttributeValue(name, "材料采购单");
								}else if("nastnum".equals(name)) {
									demandvo.setNastnum(new UFDouble(vo.getNastnum()));
								}else if("vdef30".equals(name)) {//材料采购单主表主键
									demandvo.setVdef30(vo.getPk_demand());
								}else if("vdef29".equals(name)) {//材料采购单主表主键
									demandvo.setVdef29(vo.getGdcode());//工单编码
								}else {
									demandvo.setAttributeValue(name, vo.getAttributeValue(name));
								}
							 }
							demandvos.add(demandvo);
						}
						
					}
				
						ivo.insertVOList(demandvos);
					}catch(Exception e) {
						ivo.deleteByPK(OperationMainVO.class,pk_operation);
						throw new  ValidationException(e.getMessage());
					}
					/********************************生成【需求】页签数据-end*********************************************/	
					
				}else {
					getDataModel().setExtraCondition(" and pk_corp = '1'"+" and pk_operation=  '" + pk_operation + "'"   );
					super.execute();
					throw new ValidationException("生产总订单和材料采购单没有符合条件的数据!");
				}
				
			
				
				/**
				 * 供应页签
				 * 
				 */
			try{
				//查询需求页签的物料
				List<String> liswlcodes=new ArrayList<String>();
				for(OperationDemandVO vo:demandvos) {
					liswlcodes.add(vo.getCmaterialcode());
				}
				List<String> pkwls=getInvbasdocValue2(liswlcodes);//物料主键集合
				
				//工装：1.先查询工装库：项目=批次号
				SqlBuilder sqlbuildWL=new SqlBuilder();
				
				String sqlic_onhandnum="select  vlot,cwarehouseid,cinventoryid,cinvbasid,vfree1,vfree2,vfree3,vfree4,nonhandnum "
						+ "from  ic_onhandnum where "
				//		+ "vlot =(select jobcode from  bd_jobbasfil where pk_jobbasfil='" + xmname + "' ) and "
						+ "vlot =(select jobcode from  bd_jobbasfil where pk_jobbasfil= (select pk_jobbasfil from  bd_jobmngfil where pk_jobmngfil='" + xmname + "')) and "
						+ "cwarehouseid= (select pk_stordoc  from  bd_stordoc "
						+ "where storcode='GZ001') and  nonhandnum>0  and ";
				
				sqlbuildWL.append(sqlic_onhandnum);
				sqlbuildWL.append("cinvbasid", pkwls.toArray(new String[pkwls.size()]));
				
				
				List<OnhandunmUAPVO> lisonhandnums= (List<OnhandunmUAPVO>) iuap.executeQuery(sqlbuildWL.toString(), new BeanListProcessor(OnhandunmUAPVO.class));
				for(OnhandunmUAPVO vo:lisonhandnums) {
					OperationSupplyVO opernsupplyvo=new  OperationSupplyVO();
					opernsupplyvo.setSupplytype("库存量_工装库");//供应类型
					opernsupplyvo.setPrjcode(demandvos.get(0).getPrjcode());//项目主键
					opernsupplyvo.setPrjname(demandvos.get(0).getPrjname());//项目名称
					opernsupplyvo.setPrjtypecode((demandvos.get(0).getPrjtypecode()));//项目分类
					opernsupplyvo.setPrjtypename(demandvos.get(0).getPrjtypename());//项目分类名称
					opernsupplyvo.setVbatchcode(vo.getVlot());//批次
					opernsupplyvo.setCmaterialcode(getInvbasdocValue(vo.getCinvbasid(),"invcode"));//物料主键
					opernsupplyvo.setCmaterialname(getInvbasdocValue(vo.getCinvbasid(),"invname"));//物料名称
					opernsupplyvo.setSpec(getInvbasdocValue(vo.getCinvbasid(),"invspec"));//规格
					opernsupplyvo.setModel(getInvbasdocValue(vo.getCinvbasid(),"invtype"));//型号
					opernsupplyvo.setColor(vo.getVfree1());//颜色
					opernsupplyvo.setSizing(vo.getVfree3());//定尺
					opernsupplyvo.setAlloy(vo.getVfree2());//合金
					opernsupplyvo.setStandard(vo.getVfree4());//标准
					opernsupplyvo.setNum(new UFDouble(vo.getNonhandnum()));//数量
					opernsupplyvo.setVdef1(getStordocValue(vo.getCwarehouseid(),"storname"));//仓库名称
					opernsupplyvo.setPk_operation(pk_operation);//主表主键
					supplyvos.add(opernsupplyvo);
				//	liswlpls.add(vo.getCinvbasid());
				}
				
				
				//工装：2.公共库查询：没有项目的，根据物料去查询 + 公共批次号条件
				
				SqlBuilder sqlbuild=new SqlBuilder();
				String sqlonhandnum="select  vlot,cwarehouseid,cinventoryid,cinvbasid,vfree1,vfree2,vfree3,vfree4,nonhandnum "
						+ "from  ic_onhandnum  where cwarehouseid= (select pk_stordoc  from  bd_stordoc "
						+ "where storcode='GG003') and  nonhandnum>0  and vlot='公共' and ";
				sqlbuild.append(sqlonhandnum);
				sqlbuild.append("cinvbasid", pkwls.toArray(new String[pkwls.size()]));
				
				List<OnhandunmUAPVO> lisonhandnums_gg= (List<OnhandunmUAPVO>) iuap.executeQuery(sqlbuild.toString(), new BeanListProcessor(OnhandunmUAPVO.class));
				for(OnhandunmUAPVO vo:lisonhandnums_gg) {
					OperationSupplyVO opernsupplyvo=new  OperationSupplyVO();
					opernsupplyvo.setSupplytype("库存量_公共库");//供应类型
//					opernsupplyvo.setPrjcode(demandvos.get(0).getPrjcode());//项目主键
//					opernsupplyvo.setPrjname(demandvos.get(0).getPrjname());//项目名称
//					opernsupplyvo.setPrjtypecode((demandvos.get(0).getPrjtypecode()));//项目分类
//					opernsupplyvo.setPrjtypename(demandvos.get(0).getPrjtypename());//项目分类名称
					opernsupplyvo.setVbatchcode(vo.getVlot());//批次
					opernsupplyvo.setCmaterialcode(getInvbasdocValue(vo.getCinvbasid(),"invcode"));//物料编码
					opernsupplyvo.setCmaterialname(getInvbasdocValue(vo.getCinvbasid(),"invname"));//物料名称
					opernsupplyvo.setSpec(getInvbasdocValue(vo.getCinvbasid(),"invspec"));//规格
					opernsupplyvo.setModel(getInvbasdocValue(vo.getCinvbasid(),"invtype"));//型号
					opernsupplyvo.setColor(vo.getVfree1());//颜色
					opernsupplyvo.setSizing(vo.getVfree3());//定尺
					opernsupplyvo.setAlloy(vo.getVfree2());//合金
					opernsupplyvo.setStandard(vo.getVfree4());//标准
					opernsupplyvo.setNum(new UFDouble(vo.getNonhandnum()));//数量
					opernsupplyvo.setVdef1(getStordocValue(vo.getCwarehouseid(),"storname"));//仓库名称
					opernsupplyvo.setPk_operation(pk_operation);//主表主键
					supplyvos.add(opernsupplyvo);
				}
					ivo.insertVOList(supplyvos);
					
			}catch(Exception e) {
				ivo.deleteByPK(OperationMainVO.class,pk_operation);
				ivo.deleteVOList(demandvos);
				throw new  ValidationException(e.getMessage());
			}
					
			/**
			 * 
			 * 供需平衡结果
			 * 
			 */
			List<OperationBalanceVO> bancevos=new ArrayList<OperationBalanceVO>();
			List<OperationBalanceVO> bancevoscgdd=new ArrayList<OperationBalanceVO>();
			List<OperationBalanceVO> bancevosdbdd=new ArrayList<OperationBalanceVO>();
			try {
				//查询需求页签数据
			    String sqlxq="select * from mm_operation_demand where pk_operation='"+pk_operation+"' and isnull(dr,0)=0 ";
				List<OperationDemandVO> lisopens=(List<OperationDemandVO>) iuap.executeQuery(sqlxq, new BeanListProcessor(OperationDemandVO.class));
				for(OperationDemandVO vo:lisopens) {
					OperationBalanceVO bancevo=new OperationBalanceVO();
					for(String name : bancevo.getAttributeNames()) {
						if("ts".equals(name)) {
							continue;
						}else if("demandtype".equals(name)) {
							bancevo.setDemandtype(vo.getDemandtyoe());//需求类型
						}else if("vdef28".equals(name)) {
//							UFDouble doublenum=vo.getNum();
//							if(null==doublenum && !vo.getCmaterialcode().startsWith("MA")) {
//								throw new  ValidationException("存货编码:【"+vo.getCmaterialcode()+"】主数量不能为空!");
//							}
							if (vo.getCmaterialcode().startsWith("MA")) {
								//只有辅数量
								InvbasdocVO  invbasvo = GetBaseDAOUtil.getInvVO(vo.getCmaterialcode());
							    String pk_invbasdoc = invbasvo.getPrimaryKey();
								Object objbdef6 =getHandNum("1001", "工装", pk_invbasdoc, vo.getVbatchcode(), vo.getColor(), 
							 			                vo.getSizing(), vo.getAlloy(), vo.getStandard());//现存量换算率  
								
							    if(null==objbdef6 || "".equals(objbdef6.toString())) {
									//throw new  ValidationException("存货编码:【"+vo.getCmaterialcode()+"】现存量计算的换算率不能为空!请检查!");
							    	bancevo.setVdef28(vo.getNastnum().toString());//采购主数量
							    	bancevo.setNum(vo.getNastnum());
							    	bancevo.setVdef13("1.00");//换算率
								}else {
									bancevo.setVdef28(vo.getNastnum().multiply(new UFDouble(objbdef6.toString()).setScale(2, UFDouble.ROUND_HALF_UP)).toString());//采购主数量
									bancevo.setNum(vo.getNastnum().multiply(new UFDouble(objbdef6.toString()).setScale(2, UFDouble.ROUND_HALF_UP)));
									bancevo.setVdef13(objbdef6.toString());//换算率
								}
							    
							    
							    
							}else {
								bancevo.setVdef28(vo.getNum().toString());//采购主数量
							}
							
						}else {
							bancevo.setAttributeValue(name, vo.getAttributeValue(name));
						}
					}
					
					bancevos.add(bancevo);
					//供应数据--查询供应页签数据库数据+自由项
					StringBuffer sbf=new StringBuffer();
					String gysqlw="select * from mm_operation_supply where pk_operation='"+pk_operation+"' "
							+ "and isnull(dr,0)=0 and cmaterialcode='"+bancevo.getCmaterialcode()+"' ";
					
					sbf.append(gysqlw);		
					if(null!=bancevo.getColor() && !"".equals(bancevo.getColor())) {
						sbf.append( " and color='"+bancevo.getColor()+"' ");
					}
					if(null!=bancevo.getSizing() && !"".equals(bancevo.getSizing())) {
						sbf.append( " and  sizing='"+bancevo.getSizing()+"' ");
					}
					if(null!=bancevo.getAlloy() && !"".equals(bancevo.getAlloy())) {
						sbf.append( " and alloy='"+bancevo.getAlloy()+"' ");
					}
					if(null!=bancevo.getStandard() && !"".equals(bancevo.getStandard())) {
						sbf.append( " and standard='"+bancevo.getStandard()+"' ");
					}
					
					List<OperationSupplyVO> lissupplyvos=(List<OperationSupplyVO>) iuap.executeQuery(sbf.toString(), new BeanListProcessor(OperationSupplyVO.class));
					if(null!=lissupplyvos && lissupplyvos.size()>0) {
						OperationBalanceVO bancevo113=new OperationBalanceVO();//公共库VO
						OperationBalanceVO bancevo11=new OperationBalanceVO();//工装库VO
						OperationBalanceVO bancevo1144=new OperationBalanceVO();//公共库VO_还需采购
						//判断存货公共库和工装库是否都有 +//现存量+自由项
						Map<String,List<OperationSupplyVO>> map=new HashMap<String,List<OperationSupplyVO>>();
						for(OperationSupplyVO opersuplyvo:lissupplyvos) {
							if(null!=map.get(opersuplyvo.getSupplytype())&&map.get(opersuplyvo.getSupplytype()).size()>0) {
								List<OperationSupplyVO> oldmaplisvo=map.get(opersuplyvo.getSupplytype());
								oldmaplisvo.add(opersuplyvo);
								map.put(opersuplyvo.getSupplytype()/*供应类型*/,oldmaplisvo);
							}else {
								List<OperationSupplyVO> maplisvo=new ArrayList<OperationSupplyVO>();
								maplisvo.add(opersuplyvo);
								map.put(opersuplyvo.getSupplytype()/*供应类型*/, maplisvo);
							}
						}
						if(null!=map&&map.size()<2) {
							//说明只有一个库有此存货
							if("库存量_工装库".equals(lissupplyvos.get(0).getSupplytype())) {
								bancevo11.setSupplytype("库存量_工装库");//供应类型
								bancevo11.setWarehouse("工装库");//仓库
								UFDouble gysx=UFDouble.ZERO_DBL;
								List<OperationSupplyVO> lisgzvos=map.get("库存量_工装库");
								
								//现存量+自由项
								
								
								for(OperationSupplyVO gzvo:lisgzvos) {
									gysx=gysx.add(gzvo.getNum());//供应数量
								}
								
								
								
								bancevo11.setNum(gysx);//主数量
								if (bancevo.getNum().sub(gysx).compareTo(UFDouble.ZERO_DBL)<=0) {
									//需求数量-供应数量<0
									bancevo11.setProexecutenum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo11.setMatchnum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo11.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								}else {
									//需求数量-供应数量>0
									bancevo1144=(OperationBalanceVO) bancevo11.clone();
									bancevo11.setProexecutenum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo11.setMatchnum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo11.setSurdenum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									
									if(!"生产总订单".equals(bancevo.getDemandtype())) {
										bancevoscgdd.add(bancevo1144);
									}
									
									//需要采购物料
									bancevo1144.setProexecute("采购");//建议执行
									bancevo1144.setProexecutenum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo1144.setMatchnum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo1144.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo1144.setPk_operation(pk_operation);
								}
								
								bancevo11.setPk_operation(pk_operation);
								bancevo113=(OperationBalanceVO) bancevo11.clone();
								bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
								bancevo11.setPrjname(bancevo.getPrjname());//项目名称
								bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
								bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
								bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
								bancevo11.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
								bancevo11.setCmaterialname(bancevo.getCmaterialname());//存货名称
								bancevo11.setSpec(bancevo.getSpec());//规格
								bancevo11.setModel(bancevo.getModel());//型号
								bancevo11.setColor(bancevo.getColor());//颜色
								bancevo11.setSizing(bancevo.getSizing());//定尺
								bancevo11.setAlloy(bancevo.getAlloy());//合金
								bancevo11.setStandard(bancevo.getStandard());//标准
								bancevo11.setWeight(bancevo.getWeight());//米重
								bancevo11.setUnitid(bancevo.getUnitid());//计量单位
								
								bancevo1144.setPrjcode(bancevo.getPrjcode());//项目编码
								bancevo1144.setPrjname(bancevo.getPrjname());//项目名称
								bancevo1144.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
								bancevo1144.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
								bancevo1144.setVbatchcode(bancevo.getVbatchcode());//批次
								bancevo1144.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
								bancevo1144.setCmaterialname(bancevo.getCmaterialname());//存货名称
								bancevo1144.setSpec(bancevo.getSpec());//规格
								bancevo1144.setModel(bancevo.getModel());//型号
								bancevo1144.setColor(bancevo.getColor());//颜色
								bancevo1144.setSizing(bancevo.getSizing());//定尺
								bancevo1144.setAlloy(bancevo.getAlloy());//合金
								bancevo1144.setStandard(bancevo.getStandard());//标准
								bancevo1144.setWeight(bancevo.getWeight());//米重
								bancevo1144.setUnitid(bancevo.getUnitid());//计量单位
								bancevo1144.setWeight(bancevo.getWeight());
								bancevo1144.setHeight(bancevo.getHeight());
								bancevo1144.setCastunitid(bancevo.getCastunitid());	
								bancevo1144.setNastnum(bancevo.getNastnum());
								//单据属性
								bancevo1144.setVdef1(bancevo.getVdef1());
								bancevo1144.setVdef2(bancevo.getVdef2());
								bancevo1144.setVdef3(bancevo.getVdef3());
								bancevo1144.setVdef4(bancevo.getVdef4());
								bancevo1144.setVdef5(bancevo.getVdef5());
								bancevo1144.setVdef6(bancevo.getVdef6());
								bancevo1144.setVdef7(bancevo.getVdef7());
								bancevo1144.setVdef8(bancevo.getVdef8());
								bancevo1144.setVdef9(bancevo.getVdef9());
								bancevo1144.setVdef10(bancevo.getVdef10());
								bancevo1144.setVdef11(bancevo.getVdef11());
								bancevo1144.setVdef12(bancevo.getVdef12());
								bancevo1144.setVdef13(bancevo.getVdef13());
								bancevo1144.setVdef14(bancevo.getVdef14());
								bancevo1144.setVdef15(bancevo.getVdef15());
								bancevo1144.setVdef16(bancevo.getVdef16());
								bancevo1144.setVdef17(bancevo.getVdef17());
								bancevo1144.setVdef18(bancevo.getVdef18());
								bancevo1144.setVdef19(bancevo.getVdef19());
								bancevo1144.setVdef20(bancevo.getVdef20());
								bancevo1144.setVdef21(bancevo.getVdef21());
								bancevo1144.setVdef22(bancevo.getVdef22());
								bancevo1144.setVdef23(bancevo.getVdef23());
								bancevo1144.setVdef24(bancevo.getVdef24());
								bancevo1144.setVdef25(bancevo.getVdef25());
								bancevo1144.setVdef26(bancevo.getVdef26());
								bancevo1144.setVdef27(bancevo.getVdef27());
								bancevo1144.setVdef28(bancevo.getVdef28());
								bancevo1144.setVdef29(bancevo.getVdef29());
								bancevo1144.setVdef30(bancevo.getVdef30());
								bancevo113.setSupplytype("库存量_公共库");//供应类型
								bancevo113.setWarehouse("公共库");//仓库
								bancevo113.setNum(UFDouble.ZERO_DBL);//主数量
								bancevo113.setProexecutenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
								bancevo113.setMatchnum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
								bancevo113.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								bancevos.add(bancevo11);	
								bancevos.add(bancevo1144);
								bancevos.add(bancevo113);
								
								
							}else {
								bancevo113.setSupplytype("库存量_公共库");//供应类型	
								bancevo113.setWarehouse("公共库");//仓库
//								bancevo113.setPrjcode(bancevo.getPrjcode());//项目编码
//								bancevo113.setPrjname(bancevo.getPrjname());//项目名称
//								bancevo113.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
//								bancevo113.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
//								bancevo113.setVbatchcode(bancevo.getVbatchcode());//批次
						
								UFDouble gysx=UFDouble.ZERO_DBL;
								List<OperationSupplyVO> lisggvos=map.get("库存量_公共库");
								for(OperationSupplyVO ggvo:lisggvos) {
							//		gysx=gysx.add(ggvo.getNmny());//供应数量
									gysx=gysx.add(ggvo.getNum());//供应数量
								}
								bancevo113.setNum(gysx);//主数量
								if (bancevo.getNum().sub(gysx).compareTo(UFDouble.ZERO_DBL)<=0) {
									//需求数量-供应数量<0
									bancevo113.setProexecutenum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo113.setMatchnum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo113.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo113.setPk_operation(pk_operation);
									bancevo113.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
									bancevo113.setCmaterialname(bancevo.getCmaterialname());//存货名称
									bancevo11=(OperationBalanceVO) bancevo113.clone();
									bancevo113.setSpec(bancevo.getSpec());//规格
									bancevo113.setModel(bancevo.getModel());//型号
									bancevo113.setColor(bancevo.getColor());//颜色
									bancevo113.setSizing(bancevo.getSizing());//定尺
									bancevo113.setAlloy(bancevo.getAlloy());//合金
									bancevo113.setStandard(bancevo.getStandard());//标准
									bancevo113.setWeight(bancevo.getWeight());//米重
									bancevo113.setUnitid(bancevo.getUnitid());//计量单位
									bancevo113.setVbatchcode(bancevo.getVbatchcode());//批次
									bancevo113.setVdef25(bancevo.getVdef25());
									bancevo113.setProexecute("转库");//建议执行
									
									bancevo113.setVdef1(bancevo.getVdef1());
									bancevo113.setVdef2(bancevo.getVdef2());
									bancevo113.setVdef3(bancevo.getVdef3());
									bancevo113.setVdef4(bancevo.getVdef4());
									bancevo113.setVdef5(bancevo.getVdef5());
									bancevo113.setVdef6(bancevo.getVdef6());
									bancevo113.setVdef7(bancevo.getVdef7());
									bancevo113.setVdef8(bancevo.getVdef8());
									bancevo113.setVdef9(bancevo.getVdef9());
									bancevo113.setVdef10(bancevo.getVdef10());
									bancevo113.setVdef11(bancevo.getVdef11());
									bancevo113.setVdef12(bancevo.getVdef12());
									bancevo113.setVdef13(bancevo.getVdef13());
									bancevo113.setVdef14(bancevo.getVdef14());
									bancevo113.setVdef15(bancevo.getVdef15());
									bancevo113.setVdef16(bancevo.getVdef16());
									bancevo113.setVdef17(bancevo.getVdef17());
									bancevo113.setVdef18(bancevo.getVdef18());
									bancevo113.setVdef19(bancevo.getVdef19());
									bancevo113.setVdef20(bancevo.getVdef20());
									
									bancevosdbdd.add(bancevo113);
									bancevo11.setSupplytype("库存量_工装库");//供应类型
									bancevo11.setWarehouse("工装库");//仓库
									bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
									bancevo11.setPrjname(bancevo.getPrjname());//项目名称
									bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
									bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
									bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
									bancevo11.setNum(UFDouble.ZERO_DBL);//主数量
									bancevo11.setProexecutenum(null);//建议执行数量
									bancevo11.setMatchnum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo11.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								}else {
									//需求数量-供应数量>0
									bancevo113.setProexecutenum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo113.setMatchnum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo113.setSurdenum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo113.setPk_operation(pk_operation);
									bancevo113.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
									bancevo113.setCmaterialname(bancevo.getCmaterialname());//存货名称
									bancevo113.setSpec(bancevo.getSpec());//规格
									bancevo113.setModel(bancevo.getModel());//型号
									bancevo113.setColor(bancevo.getColor());//颜色
									bancevo113.setSizing(bancevo.getSizing());//定尺
									bancevo113.setAlloy(bancevo.getAlloy());//合金
									bancevo113.setStandard(bancevo.getStandard());//标准
									bancevo113.setWeight(bancevo.getWeight());//米重
									bancevo113.setUnitid(bancevo.getUnitid());//计量单位
									bancevo11=(OperationBalanceVO) bancevo113.clone();
									bancevo113.setVbatchcode(bancevo.getVbatchcode());//批次
									String swid=UUID.randomUUID().toString();
									bancevo113.setVdef25(swid);
									bancevo113.setProexecute("转库");//建议执行
									
									bancevo113.setVdef1(bancevo.getVdef1());
									bancevo113.setVdef2(bancevo.getVdef2());
									bancevo113.setVdef3(bancevo.getVdef3());
									bancevo113.setVdef4(bancevo.getVdef4());
									bancevo113.setVdef5(bancevo.getVdef5());
									bancevo113.setVdef6(bancevo.getVdef6());
									bancevo113.setVdef7(bancevo.getVdef7());
									bancevo113.setVdef8(bancevo.getVdef8());
									bancevo113.setVdef9(bancevo.getVdef9());
									bancevo113.setVdef10(bancevo.getVdef10());
									bancevo113.setVdef11(bancevo.getVdef11());
									bancevo113.setVdef12(bancevo.getVdef12());
									bancevo113.setVdef13(bancevo.getVdef13());
									bancevo113.setVdef14(bancevo.getVdef14());
									bancevo113.setVdef15(bancevo.getVdef15());
									bancevo113.setVdef16(bancevo.getVdef16());
									bancevo113.setVdef17(bancevo.getVdef17());
									bancevo113.setVdef18(bancevo.getVdef18());
									bancevo113.setVdef19(bancevo.getVdef19());
									bancevo113.setVdef20(bancevo.getVdef20());
									
									bancevosdbdd.add(bancevo113);
									bancevo11.setSupplytype("库存量_工装库");//供应类型
									bancevo11.setWarehouse("工装库");//仓库
									bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
									bancevo11.setPrjname(bancevo.getPrjname());//项目名称
									bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
									bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
									bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
									bancevo11.setNum(UFDouble.ZERO_DBL);//主数量
									bancevo11.setProexecutenum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo11.setMatchnum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo11.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo11.setProexecute("采购");//建议执行
									bancevo11.setCastunitid(bancevo.getCastunitid());	
									bancevo11.setNastnum(bancevo.getNastnum());
									bancevo11.setWeight(bancevo.getWeight());
									bancevo11.setHeight(bancevo.getHeight());
									bancevo11.setVdef1(bancevo.getVdef1());
									bancevo11.setVdef2(bancevo.getVdef2());
									bancevo11.setVdef3(bancevo.getVdef3());
									bancevo11.setVdef4(bancevo.getVdef4());
									bancevo11.setVdef5(bancevo.getVdef5());
									bancevo11.setVdef6(bancevo.getVdef6());
									bancevo11.setVdef7(bancevo.getVdef7());
									bancevo11.setVdef8(bancevo.getVdef8());
									bancevo11.setVdef9(bancevo.getVdef9());
									bancevo11.setVdef10(bancevo.getVdef10());
									bancevo11.setVdef11(bancevo.getVdef11());
									bancevo11.setVdef12(bancevo.getVdef12());
									bancevo11.setVdef13(bancevo.getVdef13());
									bancevo11.setVdef14(bancevo.getVdef14());
									bancevo11.setVdef15(bancevo.getVdef15());
									bancevo11.setVdef16(bancevo.getVdef16());
									bancevo11.setVdef17(bancevo.getVdef17());
									bancevo11.setVdef18(bancevo.getVdef18());
									bancevo11.setVdef19(bancevo.getVdef19());
									bancevo11.setVdef20(bancevo.getVdef20());
									bancevo11.setVdef21(bancevo.getVdef21());
									bancevo11.setVdef22(bancevo.getVdef22());
									bancevo11.setVdef23(bancevo.getVdef23());
									bancevo11.setVdef24(bancevo.getVdef24());
									bancevo11.setVdef25(swid);
									bancevo11.setVdef26(bancevo.getVdef26());
									bancevo11.setVdef27(bancevo.getVdef27());
									bancevo11.setVdef28(bancevo.getVdef28());
									bancevo11.setVdef29(bancevo.getVdef29());
									bancevo11.setVdef30(bancevo.getVdef30());
									if(!"生产总订单".equals(bancevo.getDemandtype())) {
										bancevoscgdd.add(bancevo11);
									}
									
								}
								bancevos.add(bancevo113);	
								bancevos.add(bancevo11);	
							}
							
						}else {
							
							//公共库和工装库都有此存货
							/*********先查询用工装库*************/
							List<OperationSupplyVO> supplylisvos=map.get("库存量_工装库");
							bancevo11.setWarehouse("工装库");//仓库
							UFDouble gysx=UFDouble.ZERO_DBL;
							for(OperationSupplyVO supplylisvo :supplylisvos) {
								gysx=gysx.add(supplylisvo.getNum());//供应数量
							}
							bancevo11.setNum(gysx);//主数量
							if (bancevo.getNum().sub(gysx).compareTo(UFDouble.ZERO_DBL)<=0) {
								//需求数量-供应数量<0
								bancevo11.setProexecutenum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
								bancevo11.setMatchnum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
								bancevo11.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								bancevo11.setPk_operation(pk_operation);
							//	bancevo113=(OperationBalanceVO) bancevo11.clone();
								bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
								bancevo11.setPrjname(bancevo.getPrjname());//项目名称
								bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
								bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
								bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
								bancevo11.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
								bancevo11.setCmaterialname(bancevo.getCmaterialname());//存货名称
								bancevo11.setSpec(bancevo.getSpec());//规格
								bancevo11.setModel(bancevo.getModel());//型号
								bancevo11.setColor(bancevo.getColor());//颜色
								bancevo11.setSizing(bancevo.getSizing());//定尺
								bancevo11.setAlloy(bancevo.getAlloy());//合金
								bancevo11.setStandard(bancevo.getStandard());//标准
								bancevo11.setWeight(bancevo.getWeight());//米重
								bancevo11.setUnitid(bancevo.getUnitid());//计量单位
//								bancevo113.setSupplytype("库存量_公共库");//供应类型
//								bancevo113.setWarehouse("公共库");//仓库
//								bancevo113.setNum(UFDouble.ZERO_DBL);//主数量
//								bancevo113.setProexecutenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
//								bancevo113.setMatchnum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
//								bancevo113.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								bancevos.add(bancevo11);
								
							}else {
								//需求数量-供应数量>0
								bancevo11.setPk_operation(pk_operation);
								bancevo11.setProexecutenum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
								bancevo11.setMatchnum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
								UFDouble xyznum=bancevo.getNum().sub(gysx);//剩余需求主数量
								bancevo11.setSurdenum(xyznum.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
								bancevo11.setPrjname(bancevo.getPrjname());//项目名称
								bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
								bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
								bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
								bancevo11.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
								bancevo11.setCmaterialname(bancevo.getCmaterialname());//存货名称
								bancevo11.setSpec(bancevo.getSpec());//规格
								bancevo11.setModel(bancevo.getModel());//型号
								bancevo11.setColor(bancevo.getColor());//颜色
								bancevo11.setSizing(bancevo.getSizing());//定尺
								bancevo11.setAlloy(bancevo.getAlloy());//合金
								bancevo11.setStandard(bancevo.getStandard());//标准
								bancevo11.setWeight(bancevo.getWeight());//米重
								bancevo11.setUnitid(bancevo.getUnitid());//计量单位
								bancevo11.setSupplytype("库存量_工装库");//供应类型
								List<OperationSupplyVO> supplyvoggs=map.get("库存量_公共库");
								UFDouble gysxgg=UFDouble.ZERO_DBL;
								for(OperationSupplyVO supplyvogg :supplyvoggs) {
									 gysxgg=gysxgg.add(supplyvogg.getNum());//供应数量
								}
								
								if(gysxgg.sub(xyznum).compareTo(UFDouble.ZERO_DBL)>=0) {
									bancevo113.setNum(gysxgg);//主数量
									bancevo113.setProexecutenum(xyznum.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo113.setMatchnum(xyznum.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo113.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo113.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
									bancevo113.setCmaterialname(bancevo.getCmaterialname());//存货名称
									bancevo113.setSpec(bancevo.getSpec());//规格
									bancevo113.setModel(bancevo.getModel());//型号
									bancevo113.setColor(bancevo.getColor());//颜色
									bancevo113.setSizing(bancevo.getSizing());//定尺
									bancevo113.setAlloy(bancevo.getAlloy());//合金
									bancevo113.setStandard(bancevo.getStandard());//标准
									bancevo113.setWeight(bancevo.getWeight());//米重
									bancevo113.setUnitid(bancevo.getUnitid());//计量单位
									bancevo113.setVbatchcode(bancevo.getVbatchcode());//批次
									bancevo113.setVdef25(bancevo.getVdef25());
									bancevo113.setProexecute("转库");//建议执行
									
									bancevo113.setVdef1(bancevo.getVdef1());
									bancevo113.setVdef2(bancevo.getVdef2());
									bancevo113.setVdef3(bancevo.getVdef3());
									bancevo113.setVdef4(bancevo.getVdef4());
									bancevo113.setVdef5(bancevo.getVdef5());
									bancevo113.setVdef6(bancevo.getVdef6());
									bancevo113.setVdef7(bancevo.getVdef7());
									bancevo113.setVdef8(bancevo.getVdef8());
									bancevo113.setVdef9(bancevo.getVdef9());
									bancevo113.setVdef10(bancevo.getVdef10());
									bancevo113.setVdef11(bancevo.getVdef11());
									bancevo113.setVdef12(bancevo.getVdef12());
									bancevo113.setVdef13(bancevo.getVdef13());
									bancevo113.setVdef14(bancevo.getVdef14());
									bancevo113.setVdef15(bancevo.getVdef15());
									bancevo113.setVdef16(bancevo.getVdef16());
									bancevo113.setVdef17(bancevo.getVdef17());
									bancevo113.setVdef18(bancevo.getVdef18());
									bancevo113.setVdef19(bancevo.getVdef19());
									bancevo113.setVdef20(bancevo.getVdef20());
									
									bancevosdbdd.add(bancevo113);
									bancevo113.setSupplytype("库存量_公共库");//供应类型
									bancevo113.setWarehouse("公共库");//仓库
									bancevo113.setPk_operation(pk_operation);
									bancevos.add(bancevo11);
									bancevos.add(bancevo113);
									
								}else {
									bancevo113.setProexecutenum(gysxgg.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo113.setMatchnum(gysxgg.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo113.setSurdenum(xyznum.sub(gysxgg).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo113.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
									bancevo113.setCmaterialname(bancevo.getCmaterialname());//存货名称
									bancevo113.setSpec(bancevo.getSpec());//规格
									bancevo113.setModel(bancevo.getModel());//型号
									bancevo113.setColor(bancevo.getColor());//颜色
									bancevo113.setSizing(bancevo.getSizing());//定尺
									bancevo113.setAlloy(bancevo.getAlloy());//合金
									bancevo113.setStandard(bancevo.getStandard());//标准
									bancevo113.setWeight(bancevo.getWeight());//米重
									bancevo113.setUnitid(bancevo.getUnitid());//计量单位
									bancevo113.setVbatchcode(bancevo.getVbatchcode());//批次
									bancevo113.setProexecute("转库");//建议执行
									String swid=UUID.randomUUID().toString();
									bancevo113.setVdef25(swid);
									
									bancevo113.setVdef1(bancevo.getVdef1());
									bancevo113.setVdef2(bancevo.getVdef2());
									bancevo113.setVdef3(bancevo.getVdef3());
									bancevo113.setVdef4(bancevo.getVdef4());
									bancevo113.setVdef5(bancevo.getVdef5());
									bancevo113.setVdef6(bancevo.getVdef6());
									bancevo113.setVdef7(bancevo.getVdef7());
									bancevo113.setVdef8(bancevo.getVdef8());
									bancevo113.setVdef9(bancevo.getVdef9());
									bancevo113.setVdef10(bancevo.getVdef10());
									bancevo113.setVdef11(bancevo.getVdef11());
									bancevo113.setVdef12(bancevo.getVdef12());
									bancevo113.setVdef13(bancevo.getVdef13());
									bancevo113.setVdef14(bancevo.getVdef14());
									bancevo113.setVdef15(bancevo.getVdef15());
									bancevo113.setVdef16(bancevo.getVdef16());
									bancevo113.setVdef17(bancevo.getVdef17());
									bancevo113.setVdef18(bancevo.getVdef18());
									bancevo113.setVdef19(bancevo.getVdef19());
									bancevo113.setVdef20(bancevo.getVdef20());
									
									bancevosdbdd.add(bancevo113);
									bancevo113.setSupplytype("库存量_公共库");//供应类型
									bancevo113.setWarehouse("公共库");//仓库
									bancevo113.setNum(gysxgg);//主数量
									bancevo113.setPk_operation(pk_operation);
									OperationBalanceVO bancevo114=(OperationBalanceVO) bancevo11.clone();
									bancevo114.setVdef25(swid);
									bancevo114.setPk_operation(pk_operation);
									bancevo114.setNum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ));
									bancevo114.setProexecute("采购");//建议执行
									if(!"生产总订单".equals(bancevo.getDemandtype())) {
										bancevoscgdd.add(bancevo114);
									}
									bancevo114.setProexecutenum(xyznum.sub(gysxgg).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo114.setMatchnum(xyznum.sub(gysxgg).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo114.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo114.setWeight(bancevo.getWeight());
									bancevo114.setHeight(bancevo.getHeight());
									bancevo114.setCastunitid(bancevo.getCastunitid());	
									bancevo114.setNastnum(bancevo.getNastnum());
									bancevo114.setVdef1(bancevo.getVdef1());
									bancevo114.setVdef2(bancevo.getVdef2());
									bancevo114.setVdef3(bancevo.getVdef3());
									bancevo114.setVdef4(bancevo.getVdef4());
									bancevo114.setVdef5(bancevo.getVdef5());
									bancevo114.setVdef6(bancevo.getVdef6());
									bancevo114.setVdef7(bancevo.getVdef7());
									bancevo114.setVdef8(bancevo.getVdef8());
									bancevo114.setVdef9(bancevo.getVdef9());
									bancevo114.setVdef10(bancevo.getVdef10());
									bancevo114.setVdef11(bancevo.getVdef11());
									bancevo114.setVdef12(bancevo.getVdef12());
									bancevo114.setVdef13(bancevo.getVdef13());
									bancevo114.setVdef14(bancevo.getVdef14());
									bancevo114.setVdef15(bancevo.getVdef15());
									bancevo114.setVdef16(bancevo.getVdef16());
									bancevo114.setVdef17(bancevo.getVdef17());
									bancevo114.setVdef18(bancevo.getVdef18());
									bancevo114.setVdef19(bancevo.getVdef19());
									bancevo114.setVdef20(bancevo.getVdef20());
									bancevo114.setVdef21(bancevo.getVdef21());
									bancevo114.setVdef22(bancevo.getVdef22());
									bancevo114.setVdef23(bancevo.getVdef23());
									bancevo114.setVdef24(bancevo.getVdef24());
									bancevo114.setVdef25(swid);
									bancevo114.setVdef26(bancevo.getVdef26());
									bancevo114.setVdef27(bancevo.getVdef27());
									bancevo114.setVdef28(bancevo.getVdef28());
									bancevo114.setVdef29(bancevo.getVdef29());
									bancevo114.setVdef30(bancevo.getVdef30());
						
									bancevos.add(bancevo11);
									bancevos.add(bancevo113);
									bancevos.add(bancevo114);
								}
							    
								
							}
						}
						
						
					}else {
						OperationBalanceVO bancevo2=new OperationBalanceVO();
						bancevo2.setSupplytype("库存量_工装库");//供应类型
						bancevo2.setProexecute("采购");//建议执行
						if(!"生产总订单".equals(bancevo.getDemandtype())) {
							bancevoscgdd.add(bancevo2);
						}
						bancevo2.setPrjcode(bancevo.getPrjcode());//项目编码
						bancevo2.setPrjname(bancevo.getPrjname());//项目名称
						bancevo2.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
						bancevo2.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
						bancevo2.setVbatchcode(bancevo.getVbatchcode());//批次
						bancevo2.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
						bancevo2.setCmaterialname(bancevo.getCmaterialname());//存货名称
						bancevo2.setSpec(bancevo.getSpec());//规格
						bancevo2.setModel(bancevo.getModel());//型号
						bancevo2.setColor(bancevo.getColor());//颜色
						bancevo2.setSizing(bancevo.getSizing());//定尺
						bancevo2.setAlloy(bancevo.getAlloy());//合金
						bancevo2.setStandard(bancevo.getStandard());//标准
						bancevo2.setWeight(bancevo.getWeight());//米重
						bancevo2.setUnitid(bancevo.getUnitid());//计量单位
						bancevo2.setWeight(bancevo.getWeight());
						bancevo2.setHeight(bancevo.getHeight());
						bancevo2.setCastunitid(bancevo.getCastunitid());	
						bancevo2.setNastnum(bancevo.getNastnum());
						bancevo2.setVdef1(bancevo.getVdef1());
						bancevo2.setVdef2(bancevo.getVdef2());
						bancevo2.setVdef3(bancevo.getVdef3());
						bancevo2.setVdef4(bancevo.getVdef4());
						bancevo2.setVdef5(bancevo.getVdef5());
						bancevo2.setVdef6(bancevo.getVdef6());
						bancevo2.setVdef7(bancevo.getVdef7());
						bancevo2.setVdef8(bancevo.getVdef8());
						bancevo2.setVdef9(bancevo.getVdef9());
						bancevo2.setVdef10(bancevo.getVdef10());
						bancevo2.setVdef11(bancevo.getVdef11());
						bancevo2.setVdef12(bancevo.getVdef12());
						bancevo2.setVdef13(bancevo.getVdef13());
						bancevo2.setVdef14(bancevo.getVdef14());
						bancevo2.setVdef15(bancevo.getVdef15());
						bancevo2.setVdef16(bancevo.getVdef16());
						bancevo2.setVdef17(bancevo.getVdef17());
						bancevo2.setVdef18(bancevo.getVdef18());
						bancevo2.setVdef19(bancevo.getVdef19());
						bancevo2.setVdef20(bancevo.getVdef20());
						bancevo2.setVdef21(bancevo.getVdef21());
						bancevo2.setVdef22(bancevo.getVdef22());
						bancevo2.setVdef23(bancevo.getVdef23());
						bancevo2.setVdef24(bancevo.getVdef24());
						bancevo2.setVdef25(bancevo.getVdef25());
						bancevo2.setVdef26(bancevo.getVdef26());
						bancevo2.setVdef27(bancevo.getVdef27());
						bancevo2.setVdef28(bancevo.getVdef28());
						bancevo2.setVdef29(bancevo.getVdef29());
						bancevo2.setVdef30(bancevo.getVdef30());
						if(null==bancevo.getNum()) {
							String type=bancevo.getDemandtype();//需求类型
							throw new  ValidationException("需求类型:【"+type+"】存货编码:【"+bancevo.getCmaterialcode()+"】主数量不能为空!");
						}
						bancevo2.setProexecutenum(bancevo.getNum().toString());//建议执行数量
						bancevo2.setWarehouse("工装库");//仓库
						bancevo2.setNum(UFDouble.ZERO_DBL);//主数量
						bancevo2.setMatchnum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
						bancevo2.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
						bancevo2.setPk_operation(pk_operation);
						bancevos.add(bancevo2);	
						
						OperationBalanceVO bancevo3=new OperationBalanceVO();
						bancevo3.setSupplytype("库存量_公共库");//供应类型
//						bancevo3.setProexecute("采购");//建议执行
//						bancevo3.setPrjcode(bancevo.getPrjcode());//项目编码
//						bancevo3.setPrjname(bancevo.getPrjname());//项目名称
//						bancevo3.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
//						bancevo3.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
//						bancevo3.setVbatchcode(bancevo.getVbatchcode());//批次
//						bancevo3.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
//						bancevo3.setCmaterialname(bancevo.getCmaterialname());//存货名称
//						bancevo3.setSpec(bancevo.getSpec());//规格
//						bancevo3.setModel(bancevo.getModel());//型号
//						bancevo3.setColor(bancevo.getColor());//颜色
//						bancevo3.setSizing(bancevo.getSizing());//定尺
//						bancevo3.setAlloy(bancevo.getAlloy());//合金
//						bancevo3.setStandard(bancevo.getStandard());//标准
//						bancevo3.setWeight(bancevo.getWeight());//米重
//						bancevo3.setUnitid(bancevo.getUnitid());//计量单位
//						bancevo3.setProexecutenum(bancevo.getNum().toString());//建议执行数量
						bancevo3.setWarehouse("公共库");//仓库
						bancevo3.setNum(UFDouble.ZERO_DBL);//主数量
						bancevo3.setMatchnum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
						bancevo3.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
						bancevo3.setPk_operation(pk_operation);
						bancevos.add(bancevo3);	
					}
				}
			
				ivo.insertVOList(bancevos);
			}catch(Exception e) {
				ivo.deleteByPK(OperationMainVO.class,pk_operation);
				ivo.deleteVOList(demandvos);
				ivo.deleteVOList(supplyvos);
				throw new  ValidationException(e.getMessage());
			}	
				/**
				 * 
				 * 采购需求  bancevoscgdd
				 * 生成请购单
				 * 
				 */
			try {
				if(null!=bancevoscgdd && bancevoscgdd.size()>0) {
					OperationPurchaseVO[] purchasevos=new OperationPurchaseVO[bancevoscgdd.size()];
					int flg=0;
					for(OperationBalanceVO cgdd : bancevoscgdd) {
						OperationPurchaseVO vo=new OperationPurchaseVO();
						vo.setUnitid(cgdd.getUnitid());//计量单位
						vo.setCastunitid(cgdd.getCastunitid());//辅助计量单位
						vo.setPrjcode(cgdd.getPrjcode());
						vo.setPrjname(cgdd.getPrjname());
						vo.setPrjtypecode(cgdd.getPrjtypecode());
						vo.setPrjtypename(cgdd.getPrjtypename());
						vo.setVbatchcode(cgdd.getVbatchcode());
						vo.setWarehouse(cgdd.getWarehouse());
						vo.setCmaterialcode(cgdd.getCmaterialcode());
						vo.setCmaterialname(cgdd.getCmaterialname());
						vo.setSpec(cgdd.getSpec());
						vo.setModel(cgdd.getModel());
						vo.setColor(cgdd.getColor());
						vo.setSizing(cgdd.getSizing());
						vo.setAlloy(cgdd.getAlloy());
						vo.setStandard(cgdd.getStandard());
						vo.setWeight(cgdd.getWeight());
						vo.setHeight(cgdd.getHeight());
						vo.setNum(new UFDouble(cgdd.getProexecutenum()));
						vo.setNprice(cgdd.getNprice());
						vo.setNmny(cgdd.getNmny());
				//		vo.setPk_operation(pk_operation);//主表主键
						vo.setCastunitid(cgdd.getCastunitid());	
						vo.setNastnum(cgdd.getNastnum());//辅数量
						vo.setVdef1(cgdd.getVdef1());
						vo.setVdef2(cgdd.getVdef2());
						vo.setVdef3(cgdd.getVdef3());
						vo.setVdef4(cgdd.getVdef4());
						vo.setVdef5(cgdd.getVdef5());
						vo.setVdef6(cgdd.getVdef6());
						vo.setVdef7(cgdd.getVdef7());
						vo.setVdef8(cgdd.getVdef8());
						vo.setVdef9(cgdd.getVdef9());
						vo.setVdef10(cgdd.getVdef10());
						vo.setVdef11(cgdd.getVdef11());
						vo.setVdef12(cgdd.getVdef12());
						vo.setVdef13(cgdd.getVdef13());//换算率
						vo.setVdef14(cgdd.getVdef14());
						vo.setVdef15(cgdd.getVdef15());
						vo.setVdef16(cgdd.getVdef16());
						vo.setVdef17(cgdd.getVdef17());
						vo.setVdef18(cgdd.getVdef18());
						vo.setVdef19(cgdd.getVdef19());
						vo.setVdef20(cgdd.getVdef20());
					//	vo.setVdef21(cgdd.getVdef21());//cgdd.getVdef21()===窗号
					//	vo.setVdef22(cgdd.getVdef22());//cgdd.getVdef22()===专用区
						vo.setVdef23(cgdd.getVdef23());
						vo.setVdef24(cgdd.getVdef24());
						vo.setVdef25(cgdd.getVdef25());
						vo.setVdef26(cgdd.getProexecutenum());//本次采购数量
						vo.setVdef21(new UFDouble(cgdd.getProexecutenum()).div
								(new UFDouble(cgdd.getVdef28()).div(cgdd.getNastnum())).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//本次采购辅数量
						vo.setVdef27(pk_operation);//保存主表主键
						vo.setVdef28(cgdd.getVdef28());//材料采购单数量
						vo.setVdef29(cgdd.getVdef29());//工单号
						vo.setVdef30(cgdd.getVdef30());//来源单据主表主键--材料采购单
						purchasevos[flg]=vo;
						flg+=1;
					}
					
					/*
					 * PraybillHeaderVO header = new PraybillHeaderVO(); PraybillItemVO[] items =
					 * new PraybillItemVO[bancevoscgdd.size()]; // 表头赋值
					 * header.setPk_corp(PubEnv.getCorpCode());//公司
					 * header.setCoperator(ClientEnvironment.getInstance().getUser().getPrimaryKey()
					 * );//制单人 header.setDpraydate(new
					 * UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));//请购日期-
					 * ->制单日期 header.setIbillstatus(0);//单据状态 //
					 * header.setCpraypsn("1001V510000000000292");//请购人id-->业务员 //
					 * header.setCdeptid("1001V510000000000276");//请购部门id-->计划部门
					 * header.setVmemo(vbillcode);//备注 header.setDr(0);
					 * header.setCaccountyear(String.valueOf(new UFDate().getYear()));//年份
					 * header.setIpraysource(5);//请购来源 header.setIpraytype(2);//请购类型 int fg=0;
					 * for(OperationBalanceVO cgdd : bancevoscgdd) { PraybillItemVO praybillItemVO =
					 * new PraybillItemVO(); praybillItemVO.setPk_corp(PubEnv.getCorpCode()); // 公司
					 * // 表体赋值
					 * praybillItemVO.setCmangid(getCmangchid(getCmangid(cgdd.getCmaterialcode())));
					 * //存货编码 praybillItemVO.setCbaseid(getCmangid(cgdd.getCmaterialcode()));
					 * //存货基础ID praybillItemVO.setNpraynum(new UFDouble(cgdd.getMatchnum())); //数量
					 * String cprojectid = "";//项目id if(cgdd.getPrjcode().startsWith("1001")) {
					 * cprojectid = cgdd.getPrjcode(); } else { cprojectid =
					 * getprojectid(cgdd.getPrjcode()); } praybillItemVO.setCprojectid(cprojectid);
					 * // praybillItemVO.setCassistunit(demandBVO.getCastunitid());//辅助计量单位 //
					 * praybillItemVO.setNassistnum(new UFDouble(demandBVO.getNastnum()));//辅计量数量 //
					 * praybillItemVO.setVproducenum(cgdd.getVbatchcode());//批次号
					 * praybillItemVO.setDdemanddate(new
					 * UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
					 * praybillItemVO.setDsuggestdate(new
					 * UFDate(ClientEnvironment.getInstance().getBusinessDate().toString())); //
					 * praybillItemVO.setPk_purcorp(PubEnv.getCorpCode());
					 * praybillItemVO.setPk_reqcorp(PubEnv.getCorpCode());
					 * 
					 * items[fg] = praybillItemVO; fg+=1; }
					 * 
					 * // PraybillVO vo = new PraybillVO(); // vo.setParentVO(header); //
					 * vo.setChildrenVO(items); // iIplatFormEntry.processAction("SAVEBASE", "20",
					 * vo.getHeadVO().getDpraydate().toString(), null, vo, null, null);
					 */		
				
					
					ivo.insertVOArray(purchasevos);
					
					
				}
				
			}catch(Exception e) {
				ivo.deleteByPK(OperationMainVO.class,pk_operation);
				ivo.deleteVOList(demandvos);
				ivo.deleteVOList(supplyvos);
				ivo.deleteVOList(bancevos);
				throw new  ValidationException(e.getMessage());
			}	

				/**
				 * 
				 * 委外需求--不做
				 * 
				 */
				
				/**
				 * 
				 * 转库需求
				 * bancevosdbdd
				 * 生成转库单--ic_special_h 
				 */
			try {
				if(null!=bancevosdbdd &&  bancevosdbdd.size()>0) {
					OperationTransferVO[] purchasevos_zk=new OperationTransferVO[bancevosdbdd.size()];
					int flgzk=0;
					for(OperationBalanceVO cgdd : bancevosdbdd) {
						OperationTransferVO vozk=new OperationTransferVO();
						vozk.setUnitid(cgdd.getUnitid());//计量单位
						vozk.setCastunitid(cgdd.getCastunitid());//辅助计量单位
						vozk.setOutprjcode(cgdd.getPrjcode());
						vozk.setOutprjname(cgdd.getPrjname());
						vozk.setOutprjtypecode(cgdd.getPrjtypecode());
						vozk.setOutprjtypename(cgdd.getPrjtypename());
						vozk.setOutvbatchcode(cgdd.getVbatchcode());
						vozk.setCmaterialcode(cgdd.getCmaterialcode());
						vozk.setCmaterialname(cgdd.getCmaterialname());
						vozk.setOutwarehouse("公共库");//转出仓库
						vozk.setInwarehouse("工装库");//转入仓库
						vozk.setInvbatchcode(cgdd.getVbatchcode());//转入批次
						vozk.setSpec(cgdd.getSpec());
						vozk.setModel(cgdd.getModel());
						vozk.setColor(cgdd.getColor());
						vozk.setSizing(cgdd.getSizing());
						vozk.setAlloy(cgdd.getAlloy());
						vozk.setStandard(cgdd.getStandard());
						vozk.setWeight(cgdd.getWeight());
						vozk.setNum(new UFDouble(cgdd.getProexecutenum()));
						vozk.setNprice(cgdd.getNprice());
						vozk.setNmny(cgdd.getNmny());//数量
						vozk.setNastnum(cgdd.getNastnum());//辅数量
						vozk.setPk_operation(pk_operation);
						vozk.setVdef1(cgdd.getVdef1());
						vozk.setVdef2(cgdd.getVdef2());
						vozk.setVdef3(cgdd.getVdef3());
						vozk.setVdef4(cgdd.getVdef4());
						vozk.setVdef5(cgdd.getVdef5());
						vozk.setVdef6(cgdd.getVdef6());
						vozk.setVdef7(cgdd.getVdef7());
						vozk.setVdef8(cgdd.getVdef8());
						vozk.setVdef9(cgdd.getVdef9());
						vozk.setVdef10(cgdd.getVdef10());
						vozk.setVdef11(cgdd.getVdef11());
						vozk.setVdef12(cgdd.getVdef12());
						vozk.setVdef13(cgdd.getVdef13());//换算率
						vozk.setVdef14(cgdd.getVdef14());
						vozk.setVdef15(cgdd.getVdef15());
						vozk.setVdef16(cgdd.getVdef16());
						vozk.setVdef17(cgdd.getVdef17());
						vozk.setVdef18(cgdd.getVdef18());
						vozk.setVdef19(cgdd.getVdef19());
						vozk.setVdef20(cgdd.getVdef20());
						vozk.setVdef25(cgdd.getVdef25());//既有转库又有请购的标识
						purchasevos_zk[flgzk]=vozk;
						flgzk+=1;
					}
					
					/*
					 * // SpecialBillVO aggvo=new SpecialBillVO(); SpecialBillHeaderVO headvo=new
					 * SpecialBillHeaderVO(); headvo.setCbilltypecode("4K");
					 * headvo.setCinwarehouseid(getstordocpk("GZ001"));//入库仓库ID 工装
					 * headvo.setCoperatorid(ClientEnvironment.getInstance().getUser().getPrimaryKey
					 * ()); headvo.setCoutwarehouseid(getstordocpk("JZ002"));//出库仓库ID 家装
					 * headvo.setCshlddiliverdate(new
					 * UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
					 * headvo.setDbilldate(new
					 * UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
					 * headvo.setFbillflag(2); headvo.setIcheckmode(4); headvo.setIPrintCount(0);
					 * headvo.setPk_corp(PubEnv.getCorpCode()); headvo.setVshldarrivedate(new
					 * UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
					 * SpecialBillItemVO[] billitems =new SpecialBillItemVO[bancevosdbdd.size()];
					 * for(int i=0 ; i< bancevosdbdd.size() ;i++) { OperationBalanceVO
					 * vo=bancevosdbdd.get(i); SpecialBillItemVO billitem =new SpecialBillItemVO();
					 * billitem.setCinventoryid(getCmangchid(getCmangid(vo.getCmaterialcode())));
					 * billitem.setDshldtransnum(new UFDouble(vo.getMatchnum()));
					 * billitems[i]=billitem; } // aggvo.setParentVO(headvo); //
					 * aggvo.setChildrenVO(billitems); // iIplatFormEntry.processAction( "WRITE",
					 * "4K",null, null, aggvo, null, null);
					 */					
					ivo.insertVOArray(purchasevos_zk);
				}
			}catch(Exception e) {
				ivo.deleteByPK(OperationMainVO.class,pk_operation);
				ivo.deleteVOList(demandvos);
				ivo.deleteVOList(supplyvos);
				ivo.deleteVOList(bancevos);
				throw new  ValidationException(e.getMessage());
			}	
			
			//回写状态到材料采购单
			if(null!=liscodes && liscodes.size()>0) {
				SqlBuilder sqlbuf=new SqlBuilder();
				sqlbuf.append(" select * from  po_demand where ");
				sqlbuf.append("vbillcode", liscodes.toArray(new String[0]));
				List<MRPDemandVO> lisdemandvos=(List<MRPDemandVO>) iuap.executeQuery(sqlbuf.toString(), new BeanListProcessor(MRPDemandVO.class));
				for(MRPDemandVO andvo:lisdemandvos) {
					andvo.setBillstatus(10);
				}
				ivo.updateVOList(lisdemandvos);
			}
			
			getDataModel().setExtraCondition(" and pk_corp = '" + Global.getCorpPK() + "'"+" and pk_operation=  '" + pk_operation + "'"   );
	
			}else {
				//家装
				/**
				 * 1.查询安全库存的存货、起订点
				 * 2.存货查询现存量
				 * 3.没现存量的就生成请购
				 * 
				 */
				
				String sqlaqkc="select cmaterialcode,color,sizing ,alloy,standard from  ic_safetystock where isnull(dr,0)=0;";
				List<AqkcVO> lisobs=(List<AqkcVO>) iuap.executeQuery(sqlaqkc, new BeanListProcessor(AqkcVO.class));
				if(null==lisobs || lisobs.size()==0) {
					throw new  ValidationException("请先维护下安全库存！");
				}
				
				String vbillcode=new BillcodeGenerater().getBillCode("MM01", PubEnv.getPk_corp(), null, null);
				OperationMainVO opmainvo=new OperationMainVO();
				opmainvo.setBillmaker(ClientEnvironment.getInstance().getUser().getPrimaryKey());
				opmainvo.setDbilldate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
				opmainvo.setBusitype(butype);
				opmainvo.setBillstatus(8);
				opmainvo.setPk_corp(PubEnv.getCorpCode());
				opmainvo.setProjectid(xmname);
				opmainvo.setVbillcode(vbillcode);
				String pk_operation=ivo.insertVO(opmainvo);
				
				//需求页签
				String sqlaqkc2="select ic.*  from  ic_safetystock ic inner join  bd_invmandoc  bdin on bdin.pk_invmandoc=ic.cmaterialcode "
						+ "inner join  bd_invbasdoc  bdv  on bdv.pk_invbasdoc =bdin.pk_invbasdoc "
						+ "inner join  bd_invcl  invcl on invcl.pk_invcl =bdv.pk_invcl "
						+ "where isnull(ic.dr,0)=0  and isnull(bdin.dr,0)=0 "
						+ "and isnull(bdv.dr,0)=0  and isnull(invcl.dr,0)=0 and  invcl.pk_invcl='" + chfl + "' ";
			
				List<SafetystockVO> lisobs2=(List<SafetystockVO>) iuap.executeQuery(sqlaqkc2, new BeanListProcessor(SafetystockVO.class));
				
				List<OperationDemandVO> demandvos=new ArrayList<OperationDemandVO>();
				
				if(null!=lisobs2&&lisobs2.size()>0) {
					for(int i=0;i<lisobs2.size();i++) {
						OperationDemandVO  operdemandvo=new OperationDemandVO();
						SafetystockVO styvo=lisobs2.get(i);
						operdemandvo.setAlloy(styvo.getAlloy());
						operdemandvo.setColor(styvo.getColor());
						operdemandvo.setPk_operation(pk_operation);
						operdemandvo.setNum(new UFDouble(styvo.getVdef1()));
						operdemandvo.setDemandtyoe("安全库存");
						operdemandvo.setDemanddate(PubEnv.getLoginDate().toString());
//						operdemandvo.setWarehouse(getstordocpk("JZ002"));//仓库
//						operdemandvo.setCmaterialcode(getCmangchid(styvo.getCmaterialcode()));//存货编码
//						operdemandvo.setCmaterialname(styvo.getCmaterialname());//存货名称
						String cmaterpk=styvo.getCmaterialcode();
						operdemandvo.setCmaterialcode(getCmangcodename(cmaterpk,"invcode"));//存货编码
						operdemandvo.setCmaterialname(getCmangcodename(cmaterpk,"invname"));//存货名称
						operdemandvo.setSpec(styvo.getSpec());
						operdemandvo.setModel(styvo.getModel());
//						operdemandvo.setColor(styvo.getColor());
//						operdemandvo.setSizing(styvo.getSizing());
//						operdemandvo.setAlloy(styvo.getAlloy());
//						operdemandvo.setStandard(styvo.getStandard());
						operdemandvo.setColor(getdefdocid(styvo.getColor(),"YS（颜色）"));
						operdemandvo.setSizing(getdefdocid(styvo.getSizing(),"DC（定尺）"));
						operdemandvo.setAlloy(getdefdocid(styvo.getAlloy(),"HI（合金）"));
						operdemandvo.setStandard(getdefdocid(styvo.getStandard(),"BZ（标准）"));
						demandvos.add(operdemandvo);
					}
					ivo.insertVOList(demandvos);
					
					// 存货主键：cmaterialcode  color ： 颜色   sizing；尺寸  alloy ：合金   standard ： 标准   VDEF1：起订点
					List<String> lisvos=(List<String>) iuap.executeQuery("select cmaterialcode from  ic_safetystock where isnull(dr,0)=0;", new ColumnListProcessor());
					
					//查询现存量
					SqlBuilder sqlbuild=new SqlBuilder();
					String sqlonhandnum="select  vlot,cwarehouseid,cinventoryid,cinvbasid,vfree1,vfree2,vfree3,vfree4,nonhandnum "
							+ "from  ic_onhandnum  where cwarehouseid= (select pk_stordoc  from  bd_stordoc "
							+ "where storcode='JZ002') and  nonhandnum>0  and  ";
					sqlbuild.append(sqlonhandnum);
					sqlbuild.append("cinventoryid", lisvos.toArray(new String[lisvos.size()]));
					
					List<OnhandunmUAPVO> lisonhandnums_gg= (List<OnhandunmUAPVO>) iuap.executeQuery(sqlbuild.toString(), new BeanListProcessor(OnhandunmUAPVO.class));
					List<OperationSupplyVO> supplyvos=new ArrayList<OperationSupplyVO>();
					for(OnhandunmUAPVO vo:lisonhandnums_gg) {
						OperationSupplyVO opernsupplyvo=new  OperationSupplyVO();
						opernsupplyvo.setSupplytype("库存量_家装库");//供应类型
		//				opernsupplyvo.setVbatchcode(vo.getVlot());//批次
						opernsupplyvo.setCmaterialcode(getInvbasdocValue(vo.getCinvbasid(),"invcode"));//物料编码
						opernsupplyvo.setCmaterialname(getInvbasdocValue(vo.getCinvbasid(),"invname"));//物料名称
						opernsupplyvo.setSpec(getInvbasdocValue(vo.getCinvbasid(),"invspec"));//规格
						opernsupplyvo.setModel(getInvbasdocValue(vo.getCinvbasid(),"invtype"));//型号
						opernsupplyvo.setColor(vo.getVfree1());//颜色
						opernsupplyvo.setSizing(vo.getVfree3());//定尺
						opernsupplyvo.setAlloy(vo.getVfree2());//合金
						opernsupplyvo.setStandard(vo.getVfree4());//标准
						opernsupplyvo.setNum(new UFDouble(vo.getNonhandnum()));//数量
						opernsupplyvo.setVdef1(getStordocValue(vo.getCwarehouseid(),"storname"));//仓库名称
						opernsupplyvo.setPk_operation(pk_operation);//主表主键
						supplyvos.add(opernsupplyvo);
					}
					
					ivo.insertVOList(supplyvos);
					
					
					
					//供需平衡结果
					List<OperationBalanceVO> bancevos=new ArrayList<OperationBalanceVO>();
					List<OperationBalanceVO> bancevoscg=new ArrayList<OperationBalanceVO>();//采购
					//查询需求页签数据
				    String sqlxq="select * from mm_operation_demand where pk_operation='"+pk_operation+"' and isnull(dr,0)=0 ";
					List<OperationDemandVO> lisopens=(List<OperationDemandVO>) iuap.executeQuery(sqlxq, new BeanListProcessor(OperationDemandVO.class));
					for(OperationDemandVO vo:lisopens) {
						OperationBalanceVO bancevo=new OperationBalanceVO();
						for(String name : bancevo.getAttributeNames()) {
							if("ts".equals(name)) {
								continue;
							}else if("demandtype".equals(name)) {
								bancevo.setDemandtype("安全库存");//需求类型
							}else {
								bancevo.setAttributeValue(name, vo.getAttributeValue(name));
							}
							
						}
					
						bancevos.add(bancevo);
						
						//供应数据--查询供应页签数据库数据
						StringBuffer sbf=new StringBuffer();
						String gysqlw="select * from mm_operation_supply where pk_operation='"+pk_operation+"' and isnull(dr,0)=0 "
								+ "and cmaterialcode='"+bancevo.getCmaterialcode()+"' ";
						sbf.append(gysqlw);		
						if(null!=vo.getColor() && !"".equals(vo.getColor())) {
							sbf.append( " and color='"+vo.getColor()+"' ");
						}
						if(null!=vo.getSizing() && !"".equals(vo.getSizing())) {
							sbf.append( " and  sizing='"+vo.getSizing()+"' ");
						}
						if(null!=vo.getAlloy() && !"".equals(vo.getAlloy())) {
							sbf.append( " and alloy='"+vo.getAlloy()+"' ");
						}
						if(null!=vo.getStandard() && !"".equals(vo.getStandard())) {
							sbf.append( " and standard='"+vo.getStandard()+"' ");
						}
					   //查询供应页签--现存量
						List<OperationSupplyVO> lissupplyvos=(List<OperationSupplyVO>) iuap.executeQuery(sbf.toString(), new BeanListProcessor(OperationSupplyVO.class));
						if(null!=lissupplyvos && lissupplyvos.size()>0) {
							UFDouble toalnum= UFDouble.ZERO_DBL;//现存量总数量
							for(OperationSupplyVO  supiyvo:lissupplyvos) {
								UFDouble num=supiyvo.getNum();
								toalnum=toalnum.add(num);
							}
							
							//安全库存起订点大于等于现存量，需要采购
							if(new UFDouble(vo.getNum()).compareTo(toalnum)>=0) {
								OperationBalanceVO bancevo1=new OperationBalanceVO();
								bancevo1.setSupplytype("库存量_家装库");//供应类型
								bancevo1.setWarehouse("家装库");//仓库
								bancevo1.setProexecutenum(new UFDouble(vo.getNum()).sub(toalnum).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
								bancevo1.setMatchnum(new UFDouble(vo.getNum()).sub(toalnum).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
								bancevo1.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								bancevo1.setPk_operation(pk_operation);
								bancevo1.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
								bancevo1.setCmaterialname(bancevo.getCmaterialname());//存货名称
								bancevo1.setSpec(bancevo.getSpec());//规格
								bancevo1.setModel(bancevo.getModel());//型号
								bancevo1.setColor(bancevo.getColor());//颜色
								bancevo1.setSizing(bancevo.getSizing());//定尺
								bancevo1.setAlloy(bancevo.getAlloy());//合金
								bancevo1.setStandard(bancevo.getStandard());//标准
								bancevo1.setWeight(bancevo.getWeight());//米重
								bancevo1.setUnitid(bancevo.getUnitid());//计量单位
								bancevo1.setProexecute("采购");//建议执行
								bancevos.add(bancevo1);
								bancevo1.setVdef23(toalnum.setScale(2, UFDouble.ROUND_HALF_UP).toString());//现存量
								bancevo1.setVdef22(vo.getNum().setScale(2, UFDouble.ROUND_HALF_UP).toString());//起订点
								bancevoscg.add(bancevo1);
								
							}
							
							
						}else {
							OperationBalanceVO bancevo1=new OperationBalanceVO();
							bancevo1.setSupplytype("库存量_家装库");//供应类型
							bancevo1.setWarehouse("家装库");//仓库
							bancevo1.setProexecutenum(new UFDouble(vo.getNum()).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
							bancevo1.setMatchnum(new UFDouble(vo.getNum()).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
							bancevo1.setSurdenum(UFDouble.ZERO_DBL.toString());//剩余需求主数量
							bancevo1.setPk_operation(pk_operation);
							bancevo1.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
							bancevo1.setCmaterialname(bancevo.getCmaterialname());//存货名称
							bancevo1.setSpec(bancevo.getSpec());//规格
							bancevo1.setModel(bancevo.getModel());//型号
							bancevo1.setColor(bancevo.getColor());//颜色
							bancevo1.setSizing(bancevo.getSizing());//定尺
							bancevo1.setAlloy(bancevo.getAlloy());//合金
							bancevo1.setStandard(bancevo.getStandard());//标准
							bancevo1.setWeight(bancevo.getWeight());//米重
							bancevo1.setUnitid(bancevo.getUnitid());//计量单位
							bancevo1.setProexecute("采购");//建议执行
							bancevos.add(bancevo1);
							bancevo1.setVdef23(UFDouble.ZERO_DBL.setScale(2, UFDouble.ROUND_HALF_UP).toString());//现存量
							bancevo1.setVdef22(vo.getNum().setScale(2, UFDouble.ROUND_HALF_UP).toString());//起订点
							bancevoscg.add(bancevo1);
							
						}
					
					}
					
					ivo.insertVOList(bancevos);
					
					
					// 采购需求  
					if(null!=bancevoscg && bancevoscg.size()>0) {
						OperationPurchaseVO[] purchasevos=new OperationPurchaseVO[bancevoscg.size()];
						int flg=0;
						for(OperationBalanceVO cgdd : bancevoscg) {
							OperationPurchaseVO vo=new OperationPurchaseVO();
							vo.setPrjcode(cgdd.getPrjcode());
							vo.setPrjname(cgdd.getPrjname());
							vo.setPrjtypecode(cgdd.getPrjtypecode());
							vo.setPrjtypename(cgdd.getPrjtypename());
							vo.setVbatchcode(cgdd.getVbatchcode());
							vo.setWarehouse(cgdd.getWarehouse());
							vo.setCmaterialcode(cgdd.getCmaterialcode());
							vo.setCmaterialname(cgdd.getCmaterialname());
							vo.setSpec(cgdd.getSpec());
							vo.setModel(cgdd.getModel());
							vo.setColor(cgdd.getColor());
							vo.setSizing(cgdd.getSizing());
							vo.setAlloy(cgdd.getAlloy());
							vo.setStandard(cgdd.getStandard());
							vo.setWeight(cgdd.getWeight());
							
							vo.setNprice(cgdd.getNprice());
							vo.setNmny(cgdd.getNmny());
							vo.setPk_operation(pk_operation);
							vo.setVdef23(cgdd.getVdef23());//现存量
							vo.setVdef22(cgdd.getVdef22());//最大库存起订点
							//查询采购订单
							String sql="select sum (po_order_b.nordernum) nordernum  from po_order_b  inner join  bd_invbasdoc  on  po_order_b.cbaseid = bd_invbasdoc .pk_invbasdoc "
									+ "and po_order_b.vproducenum ='家装' and  isnull(po_order_b.dr,0)=0   and  isnull(bd_invbasdoc.dr,0)=0 and  bd_invbasdoc.invcode ='"+cgdd.getCmaterialcode()+"'";
							
							Object num=iuap.executeQuery(sql, new ColumnProcessor());
							
							vo.setVdef24(num==null?"0.00":new UFDouble(num.toString()).setScale(2, UFDouble.ROUND_HALF_UP).toString());//家装在途数量
							UFDouble zxcl=new UFDouble(cgdd.getProexecutenum()).sub(num==null?UFDouble.ZERO_DBL:new UFDouble(num.toString()).setScale(2, UFDouble.ROUND_HALF_UP));
							vo.setNum(zxcl);//建议执行数量
							vo.setVdef26(zxcl.setScale(2, UFDouble.ROUND_HALF_UP).toString());
							vo.setPk_operation(pk_operation);
							purchasevos[flg]=vo;
							flg+=1;
						}
						ivo.insertVOArray(purchasevos);
						
					}
				}else {
					
					throw new ValidationException("没有符合条件的安全库存数据!");
				}
				
				getDataModel().setExtraCondition(" and pk_corp = '" + Global.getCorpPK() + "'"+" and pk_operation=  '" + pk_operation + "'"   );				
			}

			
			super.execute();
			
		}
		
	}
	
	
	//项目id
    public  String getprojectid(String prjcode) throws Exception {
        String sql = "select pk_jobbasfil from bd_jobbasfil where jobcode ='"+prjcode+"' and isnull(dr,0) = 0";
        String pk_jobbasfil = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_jobbasfil == null) {
            return "";
        }
        return pk_jobbasfil;
    }
	
    /**
	 * 根据物料code查询主键
	 * @param code
	 * @return
	 * @throws BusinessException
	 */
	public String getCmangid(String code) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invbasdoc from bd_invbasdoc" + " where invcode  ='" + code + "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + code);
		}
		return cmangid;
	}

	 /**
		 * 存货管理档案
		 * @param code
		 * @return
		 * @throws BusinessException
		 */
	public String getCmangchid(String pk_invbasdoc) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invmandoc from bd_invmandoc" + " where pk_invbasdoc  ='" + pk_invbasdoc + "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + pk_invbasdoc);
		}
		return cmangid;
	}
	
	
	public String getCmangcodename(String pk_invmandoc,String value) throws BusinessException {
		String cmangid = null;
		String sql = " select invcode,invname from bd_invbasdoc where pk_invbasdoc =( select pk_invbasdoc from bd_invmandoc" + " where pk_invmandoc  ='" + pk_invmandoc + "' and dr =0 )";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor(value));
		if (cmangid == null) {
			throw new BusinessException("U8C物料主键不存在:" + pk_invmandoc);
		}
		return cmangid;
	}
	
	
	
    //物料
    public  String getInvbasdocValue(String pk_invbasdoc,String param) throws Exception {
        String sql = "select invcode,invname,invspec,invtype from bd_invbasdoc where pk_invbasdoc='"+pk_invbasdoc +"' and isnull(dr,0) = 0";
        String jobname = (String) iuap.executeQuery(sql, new ColumnProcessor(param));
        if (jobname == null) {
            return "";
        }
        return jobname;
    }
    
    //物料2-编码查询主键
    public  List<String> getInvbasdocValue2(List<String> liswlcodes) throws Exception {
    	SqlBuilder build=new SqlBuilder();
        String sql = "select pk_invbasdoc from bd_invbasdoc where isnull(dr,0) = 0 and ";
        build.append(sql);
        build.append("invcode", liswlcodes.toArray(new String[liswlcodes.size()])); 
        
        List<String> jobname = (List<String>) iuap.executeQuery(build.toString(), new ColumnListProcessor());
        if (jobname == null) {
            return null;
        }
        return jobname;
    }
    

    //仓库
    public  String getStordocValue(String pk_stordoc,String param) throws Exception {
        String sql = "select storcode,storname from bd_stordoc where pk_stordoc='"+pk_stordoc +"' and isnull(dr,0) = 0";
        String jobname = (String) iuap.executeQuery(sql, new ColumnProcessor(param));
        if (jobname == null) {
            return "";
        }
        return jobname;
    }
    
    
    public  String getstordocpk(String storcode)throws Exception{
    	String sql = "select pk_stordoc from bd_stordoc where storcode = '"+storcode+"'";
    	String pk_stordoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if(pk_stordoc == null) {
    		throw new Exception("仓库"+storcode+"未查到，请检查");
    	}
    	return pk_stordoc;
    }
    
 
    //查询自定义档案主键查询编码
    public  String getdefdocid(String pk_defdoc,String defcode) throws Exception{
    	String qrysql = "select docname from bd_defdoc where pk_defdoclist = "
    			+ "(select pk_defdoclist from bd_defdef where defcode='"+defcode+"') and pk_defdoc = '"+pk_defdoc+"'";
    	String res = (String) iuap.executeQuery(qrysql, new ColumnProcessor());
    	if(res == null) {
    		return "";
    	}
    	return res;
    }
    
    /**
	 * 查询现存量物料换算率
	 * @param pk_corp
	 * @param storcode
	 * @param cinvbasid
	 * @param vbatchcode
	 * @param color    颜色
	 * @param sizing   定尺
	 * @param alloy    合金
	 * @param standard 标准
	 * @return
	 * @throws Exception
	 */
   	public  Object  getHandNum(String pk_corp,String storcode,String cinvbasid,String vbatchcode, String color ,String sizing,String alloy,String standard)throws Exception {
   		StringBuffer sql = new StringBuffer();
   		sql.append("SELECT ");
   		sql.append(" nonhandnum/nonhandastnum as hsl");
   		sql.append(" FROM");
   		sql.append(" ic_onhandnum");
   		sql.append(" WHERE");
   		sql.append(" pk_corp = '"+pk_corp+"'");
   		sql.append(" AND cwarehouseid = ( SELECT pk_stordoc FROM bd_stordoc WHERE storcode = '"+storcode+"' and sealflag = 'N' and dr = 0)");
   		sql.append(" AND cinvbasid = '"+cinvbasid+"' AND vfree1='"+color+"' AND vfree2='"+alloy+"' AND vfree3='"+sizing+"' AND vfree4='"+standard+"' ");
   		if(vbatchcode != null) {
   			sql.append(" AND vlot = '"+vbatchcode+"'");
   		}
   		return  iuap.executeQuery(sql.toString(), new ColumnProcessor());
   	}
    
	
  }
