package u8c.bs.upifsp.pub;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.naming.Context;
import nc.itf.ic.service.IICPub_InvOnHandDMO;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.itf.uap.rbac.function.IFuncPower;
import nc.itf.uif.pub.IUifService;

/**
 * @author answer 2007-8-9
 * @类型名 : PSProxy
 * @功能 : 模块代理类
 * @版本 : v1.0
 */
public class UpifspProxy {

	public UpifspProxy() {
		// TODO 自动生成构造函数存根
	}

	/*
	 * *描述:得到locator 参数: 返回:Context 创建时间:2007-2-14 10:31:48
	 */
	private static Context getLocator() {
		return NCLocator.getInstance();
	}
	

	/**
	 * <H3>方法作用</H3>TODO<BR>
	 * 
	 * @return
	 */
	public static IUAPQueryBS getIUAPQueryBS(){
		try{ 
	 		return (IUAPQueryBS) getLocator().lookup(IUAPQueryBS.class.getName());  
	 	}catch(Exception e){ 
	 		e.printStackTrace(); 
	 		return null; 
	 	}
	}
	/**
	 * <H3>方法作用</H3>TODO<BR>
	 * 
	 * @return
	 */
	public static IUifService getIUifService(){
		try{ 
	 		return (IUifService) getLocator().lookup(IUifService.class.getName());  
	 	}catch(Exception e){ 
	 		e.printStackTrace(); 
	 		return null; 
	 	}
	}
	
	public static IICPub_InvOnHandDMO getInvOnHandItf(String iftName)
	{
		try{ 
	 		return (IICPub_InvOnHandDMO) getLocator().lookup(iftName);  
	 	}catch(Exception e){ 
	 		e.printStackTrace(); 
	 		return null; 
	 	}
	}
	
	public static IVOPersistence getIVOPersistence(){
		try{ 
	 		return (IVOPersistence) getLocator().lookup(IVOPersistence.class.getName());  
	 	}catch(Exception e){ 
	 		e.printStackTrace(); 
	 		return null; 
	 	}
	}
	public static IFuncPower getIFuncPower(){
		try{ 
	 		return (IFuncPower) getLocator().lookup(IFuncPower.class.getName());  
	 	}catch(Exception e){ 
	 		e.printStackTrace(); 
	 		return null; 
	 	}
	}
}
